var CASICLOUD_BUS_LOGIN = {};
(function($) {

	CASICLOUD_BUS_LOGIN.app = {}; //class1
	var owner = CASICLOUD_BUS_LOGIN.app;

	var serverPath = localStorage.interfaceUrl;
	var w = null;

	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length == 0) {
			return callback('帐号不能为空');
		}
		if (loginInfo.password.length == 0) {
			return callback('密码不能为空');
		}
		
		var info = plus.push.getClientInfo();
        var ios_Token = info.token;
        var android_clientid = info.clientid;
        var systemname = plus.os.name;
        var ctoken = '';
        
        if( systemname == 'iOS'){
        	ctoken = ios_Token;
        }else{
        	ctoken = android_clientid;
        }

		w = plus.nativeUI.showWaiting();
		var url = serverPath + "login.json";
		mui.ajax(url, {
			data: {
				userName: loginInfo.account,
				password: loginInfo.password,
				cToken:ctoken,
				osType:systemname
			},
			type: 'post', //HTTP请求类型
			dataType: 'json', //服务器返回json格式数据
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				if (data.status == "1") {
					console.log(JSON.stringify(data));
					w.close();
					w = null;

					var stateText = localStorage.getItem('$state') || "{}";
					var state = JSON.parse(stateText);
					state = state || {};
					state.userName = data.data.username;
					state.token = data.data.token;
					state.realname = data.data.realname;
					state.userId = data.data.userID.toString();
					state.role = data.data.role;
					state.companyId = data.data.companyId.toString();
					state.companyName = data.data.companyName;
					localStorage.setItem('$state', JSON.stringify(state));
					//登录成功
					setTimeout(function() {
						mui.openWindow({
							url: '../main/main.html',
							id: 'main',
							createNew: true,
							show: {
								aniShow: 'pop-in'
							},
							waiting: {
								autoShow: false
							}
						});
					}, 200);
					return callback(data.msg);
					//});
				} else {
					w.close();
					w = null;
					return callback(data.msg);
				}
			},
			error: function(xhr, type, errorThrown) {
				w.close();
				w = null;
				console.log(type);
				//异常处理；   

				if (type == 'timeout') {
					return callback("连接超时");
				} else if (type == 'abort') {
					return callback("连接服务器失败，请检查您的网咯");
				} else {
					return callback("登录失败");
				}

			}

		});
		return callback();
	};

	/**
	 * 修改密码
	 **/
	owner.pawupdate = function(pawInfo, callback) {
		console.log(JSON.stringify(pawInfo));
		callback = callback || $.noop;
		pawInfo = pawInfo || {};
		pawInfo.oldpassword = pawInfo.oldpassword || '';
		pawInfo.newpassword = pawInfo.newpassword || '';
		pawInfo.newpasswordConfirm = pawInfo.newpasswordConfirm || '';
        
		if (pawInfo.oldpassword.length == 0) {
			return callback('旧密码不能为空');
		}

		if (pawInfo.newpassword.length == 0) {
			return callback('新密码不能为空');
		}

		if (pawInfo.newpasswordConfirm.length == 0) {
			return callback('密码确认不能为空');
		}

		if (pawInfo.newpassword != pawInfo.newpasswordConfirm) {
			return callback('密码两次输入不一致');
		}

		if (pawInfo.newpassword.length < 6) {
			return callback('密码最短为 6 个字符');
		}

		w = plus.nativeUI.showWaiting();
		var url = serverPath + "changePassword.json";

		mui.ajax(url, {
			data: {
				token: pawInfo.token,
				userId: pawInfo.userId,
				passwordOld:pawInfo.oldpassword,
				passwordNew:pawInfo.newpassword
			},
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				console.log(JSON.stringify(data));
				if (data.status == "1") {
					w.close();
					w = null;
										
                    //plus.webview.currentWebview().close();
                    				
					return callback(data.msg);
				} else {
					w.close();
					w = null;
					return callback(data.msg);
				}
			},
			error: function(xhr, type, errorThrown) {
				w.close();
				w = null;
				if (type == 'timeout') {
					return callback("连接超时");
				} else if (type == 'abort') {
					return callback("连接服务器失败，请检查您的网咯");
				} else {
					return callback("修改失败");
				}
			}
		});

		return callback();
	};

	/**
	 * 保存登录状态
	 **/
	createState = function(userID,token,userName,userUrl, callback) {
		var state = owner.getState();
		state.userID = userID;
		state.token = token;
		state.userName = userName;
		state.userUrl = userUrl;
		owner.setState(state);
		return callback();
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};
	
	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};	

	/**
	 * 退出登录
	 **/
	owner.logout = function() {
		var state = owner.getState();
		state.token = undefined;
		state.userId = undefined;
		state.companyId = undefined;
		state.orgId = undefined;
		state.roleType = undefined;
		state.roleCode = undefined;
		state.orgCode = undefined;
		state.companyName = undefined;
		owner.setState(state);
		plus.storage.setItem("companyName", ''); //企业名称
		plus.storage.setItem("logoUrl", ''); //企业图标
		plus.storage.setItem("userNameCn", ''); //用户中文名
		
		var wvs, self, launch;
		wvs = plus.webview.all();
        self = plus.webview.currentWebview();
            launch = plus.webview.getLaunchWebview();
            for (var i = 0, len = wvs.length; i < len; i++) {
                if (wvs[i].getURL() == self.getURL() || wvs[i].getURL() == launch.getURL()) {
                    continue;
                }
                wvs[i].close();
            }plus.storage.clear();
            self.close();
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkCardID = function(cardid) {
		cardid = cardid || '';
		var myreg = /^(\d{15}$|^\d{18}$|^\d{17}(\d|X|x))$/;
		return myreg.test(cardid);
	};

	var checkEmail = function(email) {
		email = email || '';
		var myreg = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		return myreg.test(email);
	};

	var checkPhone = function(Phone) {
		Phone = Phone || '';
		var myreg = /^(0|86|17951)?(13[0-9]|15[012356789]|18[0-9]|14[57])[0-9]{8}$/;
		return myreg.test(Phone);
	};

	var checkPassword = function(Password) {
		Password = Password || '';
		var myreg = /^[A-Za-z0-9_]{6,20}$/;
		return myreg.test(Password);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
		}
		/**
		 * 获取本地是否安装客户端
		 **/
	owner.isInstalled = function(id) {
		if (id === 'qihoo' && mui.os.plus) {
			return true;
		}
		if (mui.os.android) {
			var main = plus.android.runtimeMainActivity();
			var packageManager = main.getPackageManager();
			var PackageManager = plus.android.importClass(packageManager)
			var packageName = {
				"qq": "com.tencent.mobileqq",
				"weixin": "com.tencent.mm",
				"sinaweibo": "com.sina.weibo"
			}
			try {
				return packageManager.getPackageInfo(packageName[id], PackageManager.GET_ACTIVITIES);
			} catch (e) {}
		} else {
			switch (id) {
				case "qq":
					var TencentOAuth = plus.ios.import("TencentOAuth");
					return TencentOAuth.iphoneQQInstalled();
				case "weixin":
					var WXApi = plus.ios.import("WXApi");
					return WXApi.isWXAppInstalled()
				case "sinaweibo":
					var SinaAPI = plus.ios.import("WeiboSDK");
					return SinaAPI.isWeiboAppInstalled()
				default:
					break;
			}
		}
	}
}());