var CASICLOUD_PUB_IMGUPLOAD = {};
(function($) {

	CASICLOUD_PUB_IMGUPLOAD.imgupload = {}; //class1
	var imger = CASICLOUD_PUB_IMGUPLOAD.imgupload;

	var server = localStorage.interfaceUrl + "upload.json";
	/**
	 * 拍照片
	 * @param {imgTpye} dom : 页面图片控件
	 * @param {saveType} saveType 
	 */
	imger.getImage = function(imgTpye, saveType) {
	
		var c = plus.camera.getCamera();
		c.captureImage(function(e) {
			plus.io.resolveLocalFileSystemURL(e, function(entry) {
				var s = entry.toLocalURL() + "?version=" + new Date().getTime();
				compressImage(imgTpye, s, saveType)
			}, function(e) {
				console.log("读取拍照文件错误：" + e.message);
			});
		}, function(s) {
			console.log("error" + s);
		}, {
			filename: "_doc/head.jpg"
		})
	}

	/**
	 * 本地选择图片
	 * @param {imgTpye} dom : 页面图片控件     
	 * @param {saveType} saveType :
	 */
	imger.galleryImg = function(imgTpye, saveType) {

		plus.gallery.pick(function(a) {
			plus.io.resolveLocalFileSystemURL(a, function(entry) {
				plus.io.resolveLocalFileSystemURL("_doc/", function(root) {
					root.getFile("head.jpg", {}, function(file) {
						//文件已存在
						file.remove(function() {
							console.log("file remove success");
							entry.copyTo(root, 'head.jpg', function(e) {
									var e = e.fullPath + "?version=" + new Date().getTime();
									compressImage(imgTpye, e, saveType)
								},
								function(e) {
									console.log('copy image fail:' + e.message);
								});
						}, function() {
							console.log("delete image fail:" + e.message);
						});
					}, function() {
						//文件不存在
						entry.copyTo(root, 'head.jpg', function(e) {
								var path = e.fullPath + "?version=" + new Date().getTime();
								compressImage(imgTpye, path, saveType)
							},
							function(e) {
								console.log('copy image fail:' + e.message);
							});
					});
				}, function(e) {
					console.log("get _www folder fail");
				})
			}, function(e) {
				console.log("读取拍照文件错误：" + e.message);
			});
		}, function(a) {}, {
			filter: "image"
		})

	};

	/**
	 * 图片压缩
	 * @param {path} date : 图片路径
	 * @param {saveType} saveType 
	 */
	compressImage = function(imgTpye, path, saveType) {
		plus.zip.compressImage({
				src: path,
				dst: path,
				quality: 10, //压缩到百分10
				overwrite: true
			},
			function() {
				imgTpye.src = path;
				//uploader(path, saveType);
			},
			function(error) {
				//alert("Compress error!");
			});
	}

	/**
	 * 上传文件
	 * @param {path} date : 图片路径
	 * @param {saveType} saveType 
	 */
	uploader = function(p, saveType) {
		var files = [];
		//添加文件
		files.push({
			name: "uploadkey1",
			path: p
		});
		//outSet("开始上传：")
		//alert(server);
		var wt = plus.nativeUI.showWaiting();
		var task = plus.uploader.createUpload(server, {
				method: "POST"
			},
			function(t, status) { //上传完成
				console.log(status);
				console.log(t.responseText);
				var jsondata = JSON.parse(t.responseText);
				if (status == 200 && "1" == jsondata.status) {
/*					//头像直接上传 不通过表单
					if (saveType == "reginfo-headimg") {
						headimgupload(jsondata.data[0].filePath, function(err) {
							if (err) {
								plus.nativeUI.toast(err);
								return;
							}
						});
					}
					//头像直接上传 不通过表单*/
					plus.nativeUI.toast("上传成功");
					plus.storage.setItem(saveType, jsondata.data[0].filePath); //保存服务器返回值
					wt.close();
				} else {
					plus.nativeUI.toast("上传失败");
					wt.close();
				}
			}
		);

		var state = getState();

		task.addData("mobile", state.account);
		task.addData("token", state.token);
		for (var i = 0; i < files.length; i++) {
			var f = files[i];
			task.addFile(f.path, {
				key: f.name
			});
		}
		task.start();
	}

	/**
	 * 获取当前状态
	 **/
	getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};
	
	/**
	 * 上传头像
	 **/
	headimgupload = function(imgpath, callback) {

		callback = callback || $.noop;
		imgpath = imgpath || '';
		var state = getState();
		var url = localStorage.interfaceUrl + "clientInfo.json";
		mui.ajax(url, {
			data: {
				token: state.token,
				mobile: state.account,
				avatar: imgpath
			},
			type: 'post', //HTTP请求类型
			dataType: 'json', //服务器返回json格式数据
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				var jsondata = JSON.parse(JSON.stringify(data))
				if (jsondata.status == "1") {
					plus.storage.setItem("headimg", imgpath); //保存头像
					plus.webview.getWebviewById('left-menu').reload();
					return callback(jsondata.msg);
				} else {
					return callback(jsondata.msg);
				}
			},
			error: function(xhr, type, errorThrown) {
				w.close();
				w = null;
				//异常处理；   
				if (type == 'timeout') {
					return callback("连接超时");
				} else if (type == 'abort') {
					return callback("连接服务器失败，请检查您的网咯");
				} else {
                    return callback("连接失败");
				}
			}
		});
		return callback();
	};

}(mui, window.img = {}));