﻿﻿﻿
/*
 * add by wujianfeng common utils
 */
//Set Namespace 
var CASICLOUD_PUB = {};

CASICLOUD_PUB.utils = {
	/**
	 * 时间格式化 
	 * @param {Date} date : 需要格式化的时间
	 * @param {String} fmt :格式化，如："yyyy-MM-dd HH-mm-ss"
	 */
	dateFormat: function(date, fmt) {
		//		console.log(date);
		date = this.strToDate(date);
		//		console.log(date);

		var o = {
			"M+": date.getMonth() + 1, //月份 
			"d+": date.getDate(), //日 
			"h+": date.getHours() % 12 == 0 ? 12 : date.getHours() % 12, //小时           
			"H+": date.getHours(), //小时   			
			"m+": date.getMinutes(), //分 
			"s+": date.getSeconds(), //秒 
			"S": date.getMilliseconds() //毫秒 
		};
		if(/(y+)/.test(fmt)) {
			fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
		}
		for(var k in o) {
			if(new RegExp("(" + k + ")").test(fmt)) {
				fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
			}
		}
		return fmt;
	},

	/**
	 *简单json对象拼接，相同属性内容会被覆盖。
	 * @param  Json data1
	 * @param  Json data2
	 * @return Json
	 */
	mergeJson: function(data1, data2) {

		var json1 = eval(data1);
		var json2 = eval(data2);

		var merged = {};
		for(var i in json1) {
			if(json1.hasOwnProperty(i))
				merged[i] = json1[i];
		}
		for(var i in json2) {
			if(json2.hasOwnProperty(i))
				merged[i] = json2[i];
		}
		return merged;
	},
	//购物车专用方法，{id1:num2,id2,num2},数量叠加 data1:new data,data2 :older data, data holder
	mergeJsonForCart: function(data1, data2) {

		var json1 = eval(data1);
		var json2 = eval(data2);
		console.log("json1>>>" + JSON.stringify(json1));
		console.log("json2>>>" + JSON.stringify(json2));
		var merged = {};
		for(var i in json1) {
			if(json1.hasOwnProperty(i))
				console.log(i + ">>json1>>>>" + json1[i]);
			merged[i] = json1[i] == null ? 0 : json1[i];
		}
		for(var i in json2) {
			if(json2.hasOwnProperty(i))
				console.log(i + ">>json2[i]>>>>>>" + json2[i]);
			merged[i] = (merged[i] == null ? 0 : merged[i]) + (json2[i] == null ? 0 : json2[i]);
		}
		return merged;
	},
	/**
	 * 时间格式化处理
	 */
	strToDate: function(strDate) {
		if(strDate instanceof Date) { //时间类型 不处理
			return strDate;
		} else if(typeof(strDate) == 'string') {
			if(strDate.indexOf("-") != -1) { //处理yyyy-MM-dd类型数据
				strDate = strDate.replace(/-/gi, "/");
			}
			//console.log(strDate);
			var date = new Date(strDate);
			return date;
		}
	},

	/**
	 * 保存登录状态
	 **/
	createState: function(result, callback) {
		var stateText = localStorage.getItem('$state') || "{}";
		var state = JSON.parse(stateText);
		state.userID = result.member_id;
		state.token = result.member_token;
		state.userName = result.member_name;
		state.userUrl = result.member_avatar;
		state.email = result.member_email;
		state.mobile = result.member_mobile;
		localStorage.setItem('$state', JSON.stringify(state));
		return callback();
	},

	/**
	 * 退出登录
	 **/
	logout: function() {
		var stateText = localStorage.getItem('$state') || "{}";
		var state = JSON.parse(stateText);
		state.userID = undefined;
		state.token = undefined;
		state.userName = undefined;
		state.userUrl = undefined;
		state.email = undefined;
		state.mobile = undefined;
		localStorage.setItem('$state', JSON.stringify(state));
		
		console.log("1111");

		//第三方登录
		var auths = {};
		plus.oauth.getServices(function(services) {
			for(var i in services) {
				var service = services[i];
				auths[service.id] = service;
			}
			for(var i in auths) {
				console.log(JSON.stringify(auths[i]));
				auths[i].logout(function(){
					console.log("注销成功");
				},function(e){
					console.log("注销失败："+e.message);
				});			
			}			
		}, function(e) {
			console.log("获取登录认证失败：" + e.message);
		});

	},
	
	

	/**
	 * 调用登录的参数
	 */
	paramData: function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);

	},

	/*
	 * 请求ajax
	 * @param {url} 
	 * @param {params} 
	 * @return Json 
	 */
	getAjaxData: function(url, params, callback) {
		callback = callback || $.noop;
		var w = plus.nativeUI.showWaiting();
		//console.log(url);
		//console.log(JSON.stringify(params));
		mui.ajax(url, {
			data: params,
			type: 'post', //HTTP请求类型
			dataType: 'json', //服务器返回json格式数据
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
				if(data.code == "200") { //200 正确请求
					w.close();
					w = null;
					return callback(data.data); //返回请求结果
				}else if(data.code == "100") { //200 正确请求
					w.close();
					w = null;
					CASICLOUD_PUB.utils.logout(); //退出登录
					plus.webview.getWebviewById("me.html").reload();
					plus.nativeUI.toast("用户过期，请重新登录");
				} else {
					w.close();
					w = null;
					plus.nativeUI.toast(data.msg);
				}
			},
			error: function(xhr, type, errorThrown) {
				w.close();
				//w = null;
				//console.log(JSON.stringify(xhr));
				//console.log(errorThrown);
				//console.log(type);
				//异常处理；   
				if(type == 'timeout') {
					plus.nativeUI.toast("连接超时");
				} else if(type == 'abort') {
					plus.nativeUI.toast("连接服务器失败，请检查您的网咯");
				} else {
					plus.nativeUI.toast("请求发生错误");
				}
			}
		});
	},
	/*
	 * 请求ajax
	 * @param {url} 
	 * @param {params} 
	 * @return Json data 由调用方处理返回信息
	 */
	getAjaxDataExtend: function(url, params, callback) {
		callback = callback || $.noop;
		var w = plus.nativeUI.showWaiting();
		//console.log(url);
		//console.log(JSON.stringify(params));
		mui.ajax(url, {
			data: params,
			type: 'post', //HTTP请求类型
			dataType: 'json', //服务器返回json格式数据
			timeout: 10000, //超时时间设置为10秒；
			success: function(data) {
					w.close();
					w = null;
					return callback(data); //返回请求结果
			},
			error: function(xhr, type, errorThrown) {
				w.close();
				//w = null;
				//console.log(xhr);
				//console.log(errorThrown);
				//console.log(type);
				//异常处理；   
				if(type == 'timeout') {
					plus.nativeUI.toast("连接超时");
				} else if(type == 'abort') {
					plus.nativeUI.toast("连接服务器失败，请检查您的网咯");
				} else {
					plus.nativeUI.toast("请求发生错误");
				}
			}
		});
	},
	goodsDetail: function(key, type, price) {
		mui.openWindow({
			url: '../gd/gd_detail.html',
			id: 'gd_detail.html',
			styles: {},
			extras: {
				goodsId: key,
				type: type,
				mprice: price
			},
			createNew: false, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
			show: {
				autoShow: true, //页面loaded事件发生后自动显示，默认为true
				aniShow: 'slide-in-right' //页面显示动画，默认为”slide-in-right“；
			},
			waiting: {
				autoShow: true, //自动显示等待框，默认为true
				title: '正在加载...', //等待对话框上显示的提示内容
				options: {}
			}
		});
	},
	go2pay: function(id, pay_sn, callback) { //支付公共接口
		var w = null;
		var PAYSERVER = localStorage.interfaceUrl + 'shop/pay/payment&payid';
		// 支付
		if(w) {
			return;
		} //检查是否请求订单中
		if(id === 'appleiap') {
			console.log("应用内支付");
			clicked('../pay/payment_iap.html');
			return;
		}
		console.log("----- 请求支付 -----");
		var url = PAYSERVER;
		if(id == 'alipay' || id == 'wxpay') {
			url += id;
		} else {
			plus.nativeUI.alert("当前环境不支持此支付通道！", null, "订单支付");
			return;
		}
		var appid = plus.runtime.appid;
		if(navigator.userAgent.indexOf('StreamApp') >= 0) {
			appid = 'Stream';
		}

		url += '&appid=' + appid + '&pay_sn=' + pay_sn;

		w = plus.nativeUI.showWaiting();
		// 请求支付订单
		var xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function() {
			switch(xhr.readyState) {
				case 4:
					w.close();
					w = null;
					if(xhr.status == 200) {
						console.log("----- 请求订单成功 -----");
						console.log(xhr.responseText);
						var order = xhr.responseText; //订单支付链接
						//正式支付
						plus.payment.request(pays[id], order, function(result) {
							console.log("----- 支付成功 -----");
							console.log(JSON.stringify(result));
							plus.nativeUI.alert("支付成功！", function() {
								//							back();
								//跳转到支付完成页面：跳回列表，调整首页，订单列表
								mui.openWindow({
									url: '../pay/payment_order_finsh.html',
									id: 'payment_order_finsh.html',
									styles: {},
									extras: {
										status: 1//支付成功
									}
								});

							}, "订单支付");
						}, function(e) {
							console.log("----- 支付失败 -----");
							console.log("[" + e.code + "]：" + e.message);
							plus.nativeUI.alert("支付失败：" + e.message, function(){
								//跳转到支付失败页面：跳回列表，调整首页，订单列表
								mui.openWindow({
									url: '../pay/payment_order_finsh.html',
									id: 'payment_order_finsh.html',
									styles: {},
									extras: {
										status: 0//支付失败
									}
								});
							}, "订单支付");
							
						});
						//						//模拟支付
						//						//TODO:跳回列表，调整首页，订单列表
						//						mui.openWindow({
						//							url: '../pay/payment_order_finsh.html',
						//							id: 'payment_order_finsh.html',
						//							styles: {},
						//							extras: {
						//								status: 1
						//							}
						//						});

					} else {
						console.log("----- 请求订单失败 -----");
						console.log(xhr.status);
						plus.nativeUI.alert("获取订单信息失败！", null, "订单支付");
					}
					break;
				default:
					break;
			}
		}
		xhr.open('POST', url);
		console.log("请求支付订单：" + url);
		xhr.send();

		//deal callback 
		if(callback && typeof(callback) == 'function') {
			callback();
		}

	},

	checkCardID: function(value) {
		return /^(\d{15}$|^\d{18}$|^\d{17}(\d|X|x))$/.test(value);
	},

	checkEmail: function(value) {
		return /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/.test(value);
	},

	checkPhone: function(value) {
		//return /^(0|86|17951)?(13[0-9]|15[012356789]|18[0-9]|14[57])[0-9]{8}$/.test(value);
		return /^(0|86|17951)?(12[0-9]|13[0-9]|14[0-9]|15[0-9]|16[0-9]|17[0-9]|18[0-9]|19[0-9]|11[0-9]|10[0-9])[0-9]{8}$/.test(value);
	},
	checkPhoneOrTel: function(value) {
		return /^(0[0-9]{2,3}\-)?([2-9][0-9]{6,7})+(\-[0-9]{1,4})?$|(^0?[1][358][0-9]{9}$)/.test(value);
	}

};