/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
(function() {
	var index = 0;
	var size = null;
	var imageIndexIdNum = 0;
	var starIndex = 0;
	var w;
	var feedback = {
		question: document.getElementById('question'),
		imageList: document.getElementById('image-list'),
		submitBtn: document.getElementById('submit'),
		saveBtn: document.getElementById('save')
	};
	var url = 'https://service.dcloud.net.cn/feedback';
	var url1 = localStorage.interfaceUrl+'shop/evaluategoods/add';
	feedback.files = [];
	feedback.uploader = null;
	feedback.deviceInfo = null;
	mui.plusReady(function() {
		//设备信息，无需修改
		feedback.deviceInfo = {
			appid: plus.runtime.appid,
			imei: plus.device.imei, //设备标识
			images: feedback.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: plus.runtime.version,
			plus_version: plus.runtime.innerVersion, //基座版本号
			os: mui.os.version,
			net: '' + plus.networkinfo.getCurrentType()
		}
	});
	/**
	 *提交成功之后，恢复表单项 
	 */
	feedback.clearForm = function() {
		feedback.question.value = '';
		feedback.imageList.innerHTML = '';
		feedback.newPlaceholder();
		feedback.files = [];
		index = 0;
		size = 0;
		imageIndexIdNum = 0;
		starIndex = 0;
		//清除所有星标
		mui('.icons i').each(function(index, element) {
			if(element.classList.contains('mui-icon-star-filled')) {
				element.classList.add('mui-icon-star')
				element.classList.remove('mui-icon-star-filled')
			}
		})
	};

	feedback.getFileInputArray = function() {
		return [].slice.call(feedback.imageList.querySelectorAll('.file'));
	};

	feedback.addFile = function(path) {
		feedback.files.push({
			name: "images" + "["+index+"]",
			path: path
		});
		index++;
	};

	/**
	 * 初始化图片域占位
	 */
	feedback.newPlaceholder = function() {
		var fileInputArray = feedback.getFileInputArray();
		if(fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var up = document.createElement("div");
		up.setAttribute('class', 'image-up')
			//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				feedback.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);

		//
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);

			if(mui.os.plus) {
				var a = [{
					title: "拍照"
				}, {
					title: "从手机相册选择"
				}];
				plus.nativeUI.actionSheet({
					//title: "修改头像",
					cancel: "取消",
					buttons: a
				}, function(b) {
					switch(b.index) {
						case 0:
							console.log("0");
							break;
						case 1:

							var c = plus.camera.getCamera();
							c.captureImage(function(e) {
								plus.io.resolveLocalFileSystemURL(e, function(entry) {
									var s = entry.toLocalURL();

									var name = s.substr(s.lastIndexOf('/') + 1);
									console.log("name:" + name);

									plus.zip.compressImage({
										src: s,
										dst: '_doc/' + name,
										overwrite: true,
										quality: 30
									}, function(zip) {
										size += zip.size
										console.log("filesize:" + zip.size + ",totalsize:" + size);
										if(size > (10 * 1024 * 1024)) {
											return mui.toast('文件超大,请重新选择~');
										}
										if(!self.parentNode.classList.contains('space')) { //已有图片
											feedback.files.splice(index - 1, 1, {
												name: "images" + index,
												path: s
											});
										} else { //加号
											placeholder.classList.remove('space');
											feedback.addFile(zip.target);
											feedback.newPlaceholder();
										}
										up.classList.remove('image-up');
										placeholder.style.backgroundImage = 'url(' + zip.target + ')';
									}, function(zipe) {
										mui.toast('压缩失败！')
									});

								}, function(e) {
									console.log("读取拍照文件错误：" + e.message);
								});
							}, function(s) {
								console.log("error" + s);
							}, {
								filename: "_doc/pj_" + new Date().getTime() + ".jpg"
							});
							break;

						case 2:

							plus.gallery.pick(function(e) {
								console.log(JSON.stringify(e));
								var name = e.substr(e.lastIndexOf('/') + 1);
								console.log("name:" + name);

								plus.zip.compressImage({
									src: e,
									dst: '_doc/' + name,
									overwrite: true,
									quality: 30
								}, function(zip) {
									size += zip.size
									console.log("filesize:" + zip.size + ",totalsize:" + size);
									if(size > (10 * 1024 * 1024)) {
										return mui.toast('文件超大,请重新选择~');
									}
									if(!self.parentNode.classList.contains('space')) { //已有图片
										feedback.files.splice(index - 1, 1, {
											name: "images" + index,
											path: e
										});
									} else { //加号
										placeholder.classList.remove('space');
										feedback.addFile(zip.target);
										feedback.newPlaceholder();
									}
									up.classList.remove('image-up');
									placeholder.style.backgroundImage = 'url(' + zip.target + ')';
								}, function(zipe) {
									mui.toast('压缩失败！')
								});

							}, function(e) {
								mui.toast(e.message);
							}, {});

							break;

						default:
							break;
					}
				})
			}

		}, false);

		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		feedback.imageList.appendChild(placeholder);
	};

	feedback.newPlaceholder();

	feedback.saveBtn.addEventListener('tap', function(event) {
		//判断网络连接
		if(plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) {
			return mui.toast("连接网络失败，请稍后再试");
		}
		feedback.send(mui.extend({}, feedback.deviceInfo, {
			content: feedback.question.value,
			images: feedback.files,
			score: '' + starIndex
		}))
	}, false)

	feedback.send = function(content) {
		
		feedback.uploader = plus.uploader.createUpload(url1, {
			method: 'POST'
		}, function(upload, status) {
			console.log("upload cb:" + upload.responseText);
			console.log("status"+status);
			w.close();
			w = null;
			if(status == 200) {
				mui.alert("感谢您对哈罗国际的支持，点击确定关闭", "提交成功", "确定", function() {
					feedback.clearForm();
					mui.back();
				});
			} else {
				plus.nativeUI.toast("提交失败");
			}
		});
		
		if(starIndex == 0){
			plus.nativeUI.toast("亲 商品还未评分哦");
			return;
		}
		
		if(feedback.question.value.length == 0){
			plus.nativeUI.toast("商品这么棒 说点什么吧");
			return;
		}
		
		w = plus.nativeUI.showWaiting();
		
		//添加上传数据
		//var params = CASICLOUD_PUB.utils.paramData(); //公共登录参数
		console.log(JSON.stringify(params));
		feedback.uploader.addData("token", params.token);
		feedback.uploader.addData("orderid", params.orderid);
		feedback.uploader.addData("goodsid", params.goodsid);
		feedback.uploader.addData("scores", '' + starIndex);
		feedback.uploader.addData("content", feedback.question.value);
		feedback.uploader.addData("isanonymous", '1');

		
		//添加上传文件
		mui.each(feedback.files, function(index, element) {
			var f = feedback.files[index];
			console.log("addFile:" + JSON.stringify(f));
			feedback.uploader.addFile(f.path, {
				key: f.name
			});
		});
		
		//开始上传任务
		feedback.uploader.start();
	
	};

	//应用评分
	mui('.icons').on('tap', 'i', function() {
		var index = parseInt(this.getAttribute("data-index"));
		var parent = this.parentNode;
		var children = parent.children;
		if(this.classList.contains("mui-icon-star")) {
			for(var i = 0; i < index; i++) {
				children[i].classList.remove('mui-icon-star');
				children[i].classList.add('mui-icon-star-filled');
			}
		} else {
			for(var i = index; i < 5; i++) {
				children[i].classList.add('mui-icon-star')
				children[i].classList.remove('mui-icon-star-filled')
			}
		}
		starIndex = index;
	});
	//选择快捷输入
	mui('.mui-popover').on('tap', 'li', function(e) {
		document.getElementById("question").value = document.getElementById("question").value + this.children[0].innerHTML;
		mui('.mui-popover').popover('toggle')
	})
})();